commit a551638117fd8ccf4f5611ffd1a40fead323f2ec
Author: freddy77 <freddy77>
Date:   Thu Oct 1 09:48:43 2009 +0000

    Avoid core using SQLWCHAR and TDS 4.2

diff --git a/ChangeLog b/ChangeLog
index 5965746..ec4152a 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Thu Oct  1 11:47:53 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/convert_tds2sql.c src/tds/iconv.c:
+	- Avoid core using SQLWCHAR and TDS 4.2
+
 Wed Sep 30 13:51:16 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/log.c: Avoid memory problems logging data
 
@@ -1856,4 +1860,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2874 2009/09/30 11:52:05 freddy77 Exp $
+$Id: ChangeLog,v 1.2875 2009/10/01 09:48:43 freddy77 Exp $
diff --git a/src/odbc/convert_tds2sql.c b/src/odbc/convert_tds2sql.c
index 8160f4a..a3d4f7b 100644
--- a/src/odbc/convert_tds2sql.c
+++ b/src/odbc/convert_tds2sql.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.65 2009/08/20 18:59:29 freddy77 Exp $");
+TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.66 2009/10/01 09:48:43 freddy77 Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -64,6 +64,8 @@ odbc_convert_char(TDS_STMT * stmt, TDSCOLUMN * curcol, TDS_CHAR * src, TDS_UINT
 	if (desttype == SQL_C_WCHAR) {
 		/* SQL_C_WCHAR, convert to wide encode */
 		conv = tds_iconv_get(tds, ODBC_WIDE_NAME, conv->server_charset.name);
+		if (!conv)
+			conv = tds_iconv_get(tds, ODBC_WIDE_NAME, "ISO-8859-1");
 	}
 
 	ib = src;
diff --git a/src/tds/iconv.c b/src/tds/iconv.c
index cfe6a4e..ae34f98 100644
--- a/src/tds/iconv.c
+++ b/src/tds/iconv.c
@@ -49,7 +49,7 @@
 /* define this for now; remove when done testing */
 #define HAVE_ICONV_ALWAYS 1
 
-TDS_RCSID(var, "$Id: iconv.c,v 1.140 2009/08/20 17:53:06 freddy77 Exp $");
+TDS_RCSID(var, "$Id: iconv.c,v 1.141 2009/10/01 09:48:43 freddy77 Exp $");
 
 #define CHARSIZE(charset) ( ((charset)->min_bytes_per_char == (charset)->max_bytes_per_char )? \
 				(charset)->min_bytes_per_char : 0 )
@@ -389,6 +389,10 @@ tds_iconv_open(TDSSOCKET * tds, const char *charset)
 		fOK = tds_iconv_info_init(tds->char_convs[client2server_chardata], charset, tds->env.charset);
 		if (!fOK)
 			return;
+	} else {
+		int canonic_charset = tds_canonical_charset(charset);
+		tds->char_convs[client2server_chardata]->client_charset = canonic_charsets[canonic_charset];
+		tds->char_convs[client2server_chardata]->server_charset = canonic_charsets[canonic_charset];
 	}
 
 	/* 

